include \masm32\MasmBasic\MasmBasic.inc
FLOATSTRUC STRUCT	; a colourful mix of formats
f4	REAL4 ?
f8	REAL8 ?
f10	REAL10 ?
fsrect	RECT <?>
filler	WORD ?	; 40 bytes
FLOATSTRUC ENDS
	Init
	Dim MyFS(99) As FLOATSTRUC	; 100 strucs  40 bytes = 4000 bytes
	Dim L$(99) 	; same # of strings
	For_ n=0 To 99
		Let L$(n)=Str$("String %i",n)	; set the strings
		Let esi=Str$(n+4000)	; create the strings "4000", "4001"
		MovVal MyFS(n, f4), esi	; load the REAL4 member of the structure
		Let esi=Str$(n+8000)	; create the strings "8000", "8001"
		MovVal f:xmm0, esi	; load xmm0 as a float and...
			if 1
				MyFS(ebx:n)		; much smaller and faster
				movlps MyFS(f8), xmm0	; ...just for fun, shove it into the REAL8 member
				ffree st(7)						; don't forget the FPU
				fldpi
				fimul n
				fstp MyFS(f10)				; PI*n
				mov eax, n
				mov MyFS(fsrect.left), eax
				add eax, 100
				mov MyFS(fsrect.top), eax
				add eax, 100
				mov MyFS(fsrect.right), eax
				add eax, 100
				mov MyFS(fsrect.bottom), eax
				add eax, 100
				mov MyFS(filler), ax	; filler is word sized
			else
				movlps MyFS(n, f8), xmm0	; ...just for fun, shove it into the REAL8 member
				ffree st(7)						; don't forget the FPU
				fldpi
				fimul n
				fstp MyFS(n, f10)			; PI*n
				mov eax, n
				mov MyFS(n, fsrect.left), eax
				add eax, 100
				mov MyFS(n, fsrect.top), eax
				add eax, 100
				mov MyFS(n, fsrect.right), eax
				add eax, 100
				mov MyFS(n, fsrect.bottom), eax
				add eax, 100
				mov MyFS(n, filler), ax	; filler is word sized
			endif
	Next
	Open "O", #7, "StrucStore.dat"	; open a file for output
	Store #7, MyFS()	; write all array elements
	Store #7, L$()	; append the strings, too
	Close #7
;	variants:
;	Store #7, MyFS(20)	; write element 20 only
;	Store #7, MyFS(21), 9	; write element 21-29

	Dim MyReadFS(99) As FLOATSTRUC	; 100 strucs * 40 bytes = 4000 bytes
	Open "I", #1, "StrucStore.dat"
	Recall #1, MyReadFS()
	Print Str$("The file pointer is now at byte %i\n", eax)
	Recall #1, MyRead$()
	Close
	For_ n=0 To MyReadFS(?)-1
			.if n<5 || n>99-5
				Print Str$("\n%i\t", n)		; \n is C style CrLf
				Print Str$("%i\t", MyReadFS(n, f4))
				Print Str$("%i\t", MyReadFS(n, f8))
				Print Str$("%5f\t", MyReadFS(n, f10))
				Print Str$("%i\t", MyReadFS(n, fsrect.left))
				Print Str$("%i\t", MyReadFS(n, fsrect.right))
				Print Str$("%i\t", MyReadFS(n, filler))
			.elseif n==50
				Print CrLf$, "..."
			.endif
	Next
	PrintLine CrLf$
	For_ n=0 To MyRead$(?)-1	; struct(?) yields # of elements
			.if n<5 || n>99-5
				PrintLine Str$(n), Tb$, "[", MyRead$(n), "]"
			.elseif n==50
				PrintLine "..."
			.endif
	Next
		Inkey "-- ok --"
	Exit
end start
OPT_Tmp2Asm	1
